Page MenuHome

Collada Animation Export Failure
Closed, ResolvedPublic

Description

System Information
macOS Sierra Version 10.12.5

Blender Version
Broken: 2.78.5 (2.79)
Worked: 2.78

Short description of error
Collada Animation Export Failure

I was able to resolve the issue by removing "Spider_Armature_" from each node id for type "JOINT"

So the block you want to look at is in <library_visual_scenes>

The first node has id "Spider_Armature" and is of type "NODE"

Each node of type "JOINT" in this section has "Spider_Armature_" appended to its id.

And thanks for all the hard work you guys put into Blender, I appreciate it.

*Update*
Please ignore what I posted before as a possible solution. After more testing I discovered my workaround didn't really fix the issue, in other animations I tested, incorrect joints were moving/scaling.

I also wanted to be more clear about what I mean by export failure. Normally when I export using the Collada option, I can preview the animation directly from Finder in macOS, by selecting it and hitting spacebar, or using the preview app. But in 2.78.5 (2.79), when I export a character with animation, I can only view the mesh, but there's no animation.

If you need me to elaborate on anything please let me know.

Update2:

I added four new attachments, the two files labeled 278 are the ones working, 2785 are the ones that are not working.

The files contain a Lamp with an armature consisting of 4 bones, performing a single hop.

Also another note about strange behavior, in the file where the animation is working, the exported animation has scaling in it. If you watch the animation from within Blender there is no scaling during the animation.

Exact steps for others to reproduce the error
click File > Export > Collada > Export Collada




Event Timeline

Bastien Montagne (mont29) lowered the priority of this task from 90 to Normal.Jul 16 2017, 7:39 PM
Phi (Phi) updated the task description. (Show Details)Jul 17 2017, 2:44 PM

If possible can you try to find a super simple example that demonstrates the failure in 2.78.5 but works in the 2.78 release? Then provide the blend and 2 collada files, one that works (exported from 2.78) and one that is broken (exported from 2.78.5). Then it is much easier to inspect the model and see what has gone wrong.

If you can not find a simple demo, then maybe you can still provide a working dae of the spider from 2.78 and a broken dae from 2.78.5 that would still help.
thanks!

Phi (Phi) updated the task description. (Show Details)Jul 17 2017, 3:33 PM

Hi, Phi;

Thanks for reporting and helping to solve this issue by providing the extra demo files!
I believe that i have fixed the animation curve export issue. Please can you check that all is ok now and report back when it still fails?

Regarding the other issue about scaling, it may be better to create a new report for that, so things do not get mixed up. You can assign me directly if you like. Then i get notified right away :)

cheers,
Gaia

Phi (Phi) changed the task status from Resolved to Unknown Status.Jul 18 2017, 3:11 AM

I'm really new to Blender so I hope I'm following the correct steps to grab the latest build with your fix implemented.

  1. Visited https://builder.blender.org/download/
  1. Downloaded Mac OS X 64 bit Official blender-2.78-3d1e5bca88-OSX-10.6-x86_64.zip 114M Mon Jul 17 05:03:21 2017
  1. Removed old copy of Blender and ran new copy.

I've tested the Collada exporter with the original lamp blend files and also other blend animations that exported correctly in the previous version 2.78. As far as I could tell, it appears the changes implemented did not resolve the issue. I'm seeing the same behavior as before, unable to play the animation in Preview app or in Xcode, when previously the animations were playable when exported from 2.78.

I thought my original workaround was the cause of the scaling issues, but I came to the conclusion that the scaling issues were most likely coming from my inexperience with Blender. Because whenever I would export other people's animated meshes (with my workaround), there was no scaling issues, only in mine.

I'll try to briefly describe my workaround again.

  1. Find <library_visual_scenes> section of collada file.
  2. For each Node of type Joint replace the id with the name.

e.g.
Original: <node id="LampRig_Base" name="Base" sid="Base" type="JOINT">
Corrected: <node id="Base" name="Base" sid="Base" type="JOINT">

In the exported LampHop2785 file I manually implemented these changes to solve the issue.
I also wrote a short script to apply these changes to larger animations with hundreds of bones to verify the fix, testing with other people's blender animation files.

I'm happy to help Gaia, I appreciate the open communication and the hard work of the Blender community.

About assigning task to you, I don't know how Blender operates, like is there a team of people working on Collada or is it just you? If there's a team I'd like to assign task in such a way that it's not piled onto one person. But thanks again and I hope you make more progress on this issue, I'll keep researching this issue further to see what other possible fixes there could be.

Phi (Phi) changed the task status from Unknown Status to Resolved.Jul 18 2017, 8:31 AM

I just downloaded the most recent build, and your fix worked! Thanks so much for solving the issue, I'm really looking forward to using Blender thanks to you!